let Buffer = require('buffer').Buffer,
    Random=require('random-js'),
    Mt=require('mersenne-twister'),
    Chance = require('chance');

export class Sp8deCrypto {
    constructor(eth = undefined) {
        this.EthJS = !eth ? window.EthJS.Util : eth;
    }

    sing(privateKey, seed, nonce) {
        if (privateKey === undefined ||
            seed === undefined ||
            nonce === undefined) {
            console.error('Invalid parameters');
            return null;
        }
        let pubKey = this.getPubKey(privateKey),
            message = `${pubKey};${seed};${nonce}`,
            msg = this.EthJS.hashPersonalMessage(this.EthJS.toBuffer(message)),
            signed = this.EthJS.ecsign(msg, this.EthJS.toBuffer(privateKey)),
            tx = signed.r.toString('hex') + signed.s.toString('hex') + this.EthJS.stripHexPrefix(this.EthJS.intToHex(signed.v));
        return {
            pubKey: pubKey,
            message: message,
            sign: this.EthJS.addHexPrefix(tx),
            version: '3',
            signer: 'MEW'
        };
    }

    getPubKey(privateKey) {
        if (!privateKey) {
            console.error('Invalid parameter');
            return;
        }
        return this.EthJS.addHexPrefix(this.EthJS.privateToAddress(privateKey).toString('hex'))
    }

    getRandomFromArray(array, min, max) {
        console.group('Mt')
        let mt=new Mt(...[1,2,3]);
        console.log(mt);
        console.log(new Mt([1,2,3]));
        console.groupEnd()

        console.group('Chance')
        let ch= new Chance(...[1,2,3]);
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log(ch.integer({ min: 1, max: 6 }))
        console.log( new Chance(...[1,2,3]).unique(chance.integer, 6, {min: 1, max: 6}))
        console.groupEnd()

        console.group('Random')
        let r=new Random(Random.engines.mt19937().seedWithArray([1,2,3]));
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log('...')
        r=new Random(Random.engines.mt19937().seedWithArray(...[1,2,3]));
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.log(r.integer(1, 6))
        console.groupEnd()



        //return new Chance(...array).integer({min: min, max: max});

        /*if (array === undefined ||
            !Array.isArray(array) ||
            begin === undefined ||
            end === undefined) {
            console.error('Invalid parameters');
            return;
        }
        return new Random(Random.engines.mt19937().seedWithArray(array)).integer(begin, end);*/
    }

    generateSeed() {
        let rnd = new Uint32Array(1);
        window.crypto.getRandomValues(rnd);
        return rnd[0];
    };

    validate(signedMessage) {
        let item, hash, sign, pubKey;
        try {
            if (!signedMessage) throw new TypeError('Please enter signed message');
            item = typeof item === 'string' ? JSON.parse(signedMessage) : signedMessage;
            if (!item.sign) throw new TypeError('Empty sign');
            if (item.sign.length % 2 !== 0) throw new TypeError('Invalid hex string');
            sign = Buffer.from(this.getNakedAddress(item.sign), 'hex');
            if (sign.length !== 65) throw new TypeError('sign length is not valid');
            sign[64] = sign[64] === 0 || sign[64] === 1 ? sign[64] + 27 : sign[64];
            hash = this.EthJS.hashPersonalMessage(this.EthJS.toBuffer(item.message));
            if (item.version === '3') {
                if (item.signer === 'trezor') {
                    hash = this.getTrezorHash(item.message);
                } else if (item.signer === 'ledger') {
                    hash = this.EthJS.hashPersonalMessage(Buffer.from(item.message));
                }
            } else if (item.version === '1') {
                hash = this.EthJS.sha3(item.message);
            }
            pubKey = this.EthJS.ecrecover(
                hash,
                sign[64],
                sign.slice(0, 32),
                sign.slice(32, 64)
            );

            if (this.getNakedAddress(item.pubKey) !== this.EthJS.pubToAddress(pubKey).toString('hex')) throw new TypeError('sign is not valid');
        } catch (e) {
            if (e instanceof SyntaxError) console.error('JSON is not valid');
            else console.error(e);
            return false;
        }
        return true;
    }

    getNakedAddress(address) {
        return address.toLowerCase().replace('0x', '');
    };

    getTrezorLenBuf(msgLen) {
        if (msgLen < 253) return Buffer.from([msgLen & 0xff]);
        else if (msgLen < 0x10000)
            return Buffer.from([253, msgLen & 0xff, (msgLen >> 8) & 0xff]);
        else {
            return Buffer.from([
                254,
                msgLen & 0xff,
                (msgLen >> 8) & 0xff,
                (msgLen >> 16) & 0xff,
                (msgLen >> 24) & 0xff
            ]);
        }
    };

    getTrezorHash(msg) {
        return this.EthJS.sha3(
            Buffer.concat([
                this.EthJS.toBuffer('\u0019Ethereum Signed Message:\n'),
                this.getTrezorLenBuf(msg.length),
                this.EthJS.toBuffer(msg)
            ])
        );
    };
}




